//+------------------------------------------------------------------+
//|                                                  stochas&rsi.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Frenky Yard"
#property link "http://www.ayfixfox.com"
                          
//---- indicator settings
 #property indicator_separate_window
 #property indicator_buffers 2
 #property indicator_minimum -5
 #property indicator_maximum 105
 #property indicator_color1 Maroon
 #property indicator_color2 Blue
 
//---- input parameters
 extern int RSI_Periods=14;
 extern int Percent_K=14;
 extern int Percent_D=9;
 extern int NumOfBars=0;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsPushNotif = false;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   arrowsVisible      = true;
extern string arrowsIdentifier   = "CorSsa Arrows1";
extern double arrowsDisplacement = 1.0;
extern color  arrowsUpColor      = Green;
extern color  arrowsDnColor      = Red;
extern int    arrowsUpCode       = 241;
extern int    arrowsDnCode       = 242;

 
//---- buffers
 double Buffer1[];
 double Buffer2[];
 double trend[];
 
//+------------------------------------------------------------------+
 //| Custom indicator initialization function |
 //+------------------------------------------------------------------+
 int init()
 {
 //---- indicators
 IndicatorBuffers(3);
 SetIndexBuffer(0,Buffer1); SetIndexLabel(0,"StochRSI");
 SetIndexBuffer(1,Buffer2); SetIndexLabel(1,"Signal");
 SetIndexBuffer(2,trend);
 
//----
return(0);
 }
 //+------------------------------------------------------------------+
 //| Custor indicator deinitialization function |
 //+------------------------------------------------------------------+
 int deinit()
{  
   if (arrowsVisible) deleteArrows();  
   return(0); 
}

 //+------------------------------------------------------------------+
 //| Custom indicator iteration function |
 //+------------------------------------------------------------------+
 int start()
 {
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);

   for(int i=limit;i>=0;i--)
   {
      double Current_RSI = iRSI(NULL,0,RSI_Periods,PRICE_OPEN,i);
      double Highest_RSI = Current_RSI;
      double Lowest_RSI  = Current_RSI;
 
      for(int x=0;x<=Percent_K;x++)
      {
         Lowest_RSI = MathMin(Lowest_RSI ,iRSI(NULL,0,RSI_Periods,PRICE_OPEN,i+x));
         Highest_RSI= MathMax(Highest_RSI,iRSI(NULL,0,RSI_Periods,PRICE_OPEN,i+x));
      }
 
 
      if ((Highest_RSI-Lowest_RSI)!=0) Buffer1[i]=((Current_RSI-Lowest_RSI)/(Highest_RSI-Lowest_RSI))*100;

      double sum_K=0; for(x=0;x<=Percent_D;x++) sum_K+=Buffer1[i+x];
      Buffer2[i]=sum_K/Percent_D;
      trend[i] = trend[i+1];
         if (Buffer1[i]>Buffer2[i]) trend[i] =  1;
         if (Buffer1[i]<Buffer2[i]) trend[i] = -1;
             manageArrow(i);
  }
   manageAlerts();
 //----
 return(0);
 }


//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Stoch & rsi crossed signal ",doWhat);
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(StringConcatenate(Symbol()," Stoch & rsi"),message);
          if (alertsPushNotif) SendNotification(StringConcatenate(Symbol()," Stoch & rsi "+message));
          if (alertsSound)     PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      deleteArrow(Time[i]);
      if (trend[i] != trend[i+1])
      {
         if (trend[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode,false);
         if (trend[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDnCode,true);
      }
   }
}               
void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsDisplacement * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsDisplacement * gap);
}
void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}